# -*- mode: ruby -*-
# vi: set ft=ruby :

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.
Vagrant.configure("2") do |config|

#  config.ssh.insert_key = true
#  config.ssh.private_key_path = ".vagrant/machines/default/virtualbox/private_key"

  # nic type
  config.vm.provider "virtualbox" do |v|
#    v.default_nic_type = "Am79C970A"
    v.default_nic_type = "82540EM"
  end

  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  # Every Vagrant development environment requires a box. You can search for
  # boxes at https://vagrantcloud.com/search.
  config.vm.box = "bento/ubuntu-18.04"

  # Disable automatic box update checking. If you disable this, then
  # boxes will only be checked for updates when the user runs
  # `vagrant box outdated`. This is not recommended.
  # config.vm.box_check_update = false

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # NOTE: This will enable public access to the opened port
  # config.vm.network "forwarded_port", guest: 80, host: 8080

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine and only allow access
  # via 127.0.0.1 to disable public access
  # config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"

  # Create a private network, which allows host-only access to the machine
  # using a specific IP.

  # config.vm.network "private_network", type: "dhcp"

  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.

  config.vm.network "public_network",
    bridge: "Intel(R) Ethernet Connection (2) I218-V",
    use_dhcp_assigned_default_route: true

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.

  #config.winnfsd.uid = 33
  #config.winnfsd.gid = 33

#  config.vm.synced_folder "..", "/var/www", #type: "smb",
#    owner: "www-data", group: "www-data",
#    #smb_host: "alex-winpc", smb_username:"alexander", smb_password:"IonFus",
#    #mount_options: ["username=alexander", "password=IonFus", "dir_mode=0775", "file_mode=0775", "uid=33", "gid=33"]
#    mount_options: ["dmode=0775", "fmode=0775", "uid=33", "gid=33"]
#    #nfs_udp: true
#    #mount_option: ["dmode=775", "fmode=664"]
#    #map_uid: 33,
#    #map_gid: 33


  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  config.vm.provider "virtualbox" do |vb|
  #   # Display the VirtualBox GUI when booting the machine
  #   vb.gui = true
  #
  #   # Customize the amount of memory on the VM:
      vb.memory = "6000"
      vb.cpus = 4
      vb.name = "www.oooast.test"
  end
  #
  # View the documentation for the provider you are using for more
  # information on available options.

  config.hostmanager.enabled = true
  config.hostmanager.manage_host = true
  config.hostmanager.manage_guest = false
  config.hostmanager.ignore_private_ip = true
  config.hostmanager.include_offline = true
  config.hostmanager.ip_resolver = proc do |vm, resolving_vm|
    if hostname = (vm.ssh_info && vm.ssh_info[:host])
# 16.04->18.04      `vagrant ssh -c /sbin/ifconfig | grep "inet addr" | grep "192.168.1" | tail -n 1 | grep -E -o "[0-9\.]+" | head -n 1 2>&1`.split("\n").first[/(\d+\.\d+\.\d+\.\d+)/, 1]
      `vagrant ssh -c /sbin/ifconfig | grep "inet " | grep "192.168.1" | tail -n 1 | grep -E -o "[0-9\.]+" | head -n 1 2>&1`.split("\n").first[/(\d+\.\d+\.\d+\.\d+)/, 1]
    end
  end
  config.vm.hostname = 'vagrant'
  config.hostmanager.aliases = %w(vagrant.lan.pototskiy.net oooast.test www.oooast.test)
#   config.vm.define 'vagrant' do |node|
#     node.vm.hostname = 'vagrant'
# #    node.vm.network :public_network
#     node.hostmanager.aliases = %w(vagrant.lan.pototskiy.net oooast.test www.oooast.test)
#   end

  # Enable provisioning with a shell script. Additional provisioners such as
  # Puppet, Chef, Ansible, Salt, and Docker are also available. Please see the
  # documentation for more information about their specific syntax and use.

  # default router
  config.vm.provision "shell",
    run: "always",
    inline: "route add default gw 192.168.1.1"

  # delete default gw on eth0
  config.vm.provision "shell",
    run: "always",
    inline: "eval `route -n | awk '{ if ($8 ==\"eth0\" && $2 != \"0.0.0.0\") print \"route del default gw \" $2; }'`"

  config.vm.provision "shell", run: "always", inline: "echo OOO Ast Magento site"

  config.vm.provision "file", source: "files/ssl-vagrant-server.crt", destination: "/tmp/ssl-vagrant-server.crt"
  config.vm.provision "file", source: "files/ssl-vagrant-server.key", destination: "/tmp/ssl-vagrant-server.key"
  config.vm.provision "shell", inline: "bash /vagrant/scripts/provision.sh"

end
